#	This file is part of SurrealServices.
#
#	SurrealServices is free software; you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation; either version 2 of the License, or
#	(at your option) any later version.
#
#	SurrealServices is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with SurrealServices; if not, write to the Free Software
#	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
package fmt;
use strict;

sub columnar(@) {
	my (@mlen, @out);

	foreach my $x (@_) {
		for(my $i; $i<@$x; $i++) {
			my $nc = $x->[$i];
			$nc =~ s/\002//g;
			my $len = length($nc);
			$mlen[$i] = $len if $len > $mlen[$i];
		}
	}

	foreach my $x (@_) {
		my $str = '  ';
		for(my $i; $i<@$x; $i++) {
			my $nc = $x->[$i];
			$nc =~ s/\002//g;
			$str .= $x->[$i] . ' ' x (($mlen[$i] - length($nc) + ($mlen[$i] ? 2 : 0)));
		}
		$str =~ s/ +$//; $str = ' ' unless $str;
		push @out, $str;
	}
	push @out, '  (empty list)' unless @out;
	push @out, ' --';

	return @out;
}

sub columnar2(@) {
	my (@mlen, @out);

	foreach my $x (@_) {
		for(my $i; $i<@$x; $i++) {
			my $nc = $x->[$i];
			$nc =~ s/\002//g;
			my $len = length($nc);
			$mlen[$i] = $len if $len > $mlen[$i];
		}
	}

	foreach my $x (@_) {
		my $str = '  ';
		for(my $i; $i<@$x; $i++) {
			my $nc = $x->[$i];
			$nc =~ s/\002//g;
			$str .= $x->[$i] . ' ' x (($mlen[$i] - length($nc) + ($mlen[$i] ? 2 : 0)));
		}
		$str =~ s/ +$//; $str = ' ' unless $str;
		push @out, $str;
	}
	push @out, '  (empty list)' unless @out;

	return @out;
}

1;
